import java.util.LinkedList;

public class City {
	
	private String name;
	private LinkedList<City> destinations;
	private boolean visited; 
	
	public City(String name) {
		this.name = name;
		this.destinations = new LinkedList<City>();
		this.visited = false;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public boolean isVisited() {
		return visited;
	}

	public void setVisited(boolean visited) {
		this.visited = visited;
	}

	public void addDestination(City destination) {
		this.destinations.add(destination);
	}
	
	public City[] getDestinations() {
		City[] cities = new City[this.destinations.size()];
		
		for ( int i = 0 ; i < cities.length ; i++ ) {
			cities[i] = this.destinations.get(i);
		}
		
		return cities;
	}
	
	public City[] getUnvisitedDestinations() {
		City[] allDestinations = this.getDestinations();
		
		int count = 0;
		for ( int i = 0 ; i < allDestinations.length ; i++ ) {
			if (!allDestinations[i].isVisited()) {
				count++;
			}
		}
		
		if (count == 0) {
			return null;
		} else {
			City[] unvisitedCities = new City[count];
			
			int index = 0;
			
			for ( int i = 0 ; i < allDestinations.length ; i++ ) {
				if (!allDestinations[i].isVisited()) {
					unvisitedCities[index++] = allDestinations[i];
				}
			}
			return unvisitedCities;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof City) {
			City otherCity = (City) obj;
			if (this.name.equals(otherCity.getName())) {
				return true;
			}
		}
		
		return false;
	}

	@Override
	public String toString() {
		return this.name;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
