import java.util.Stack;

public class TripFinder {

	private City newYork, providence, boston, philadelphia, 
					washington, miami, dallas, losAngeles, chicago, 
					sanFrancisco;
	
	public TripFinder() {
		this.newYork = new City("New York");
		this.providence = new City("Providence");
		this.boston = new City("Boston");
		this.philadelphia = new City("Philadelphia");
		this.washington = new City("Washington D.C.");
		this.miami = new City("Miami");
		this.dallas = new City("Dallas");
		this.chicago = new City("Chicago");
		this.sanFrancisco = new City("SanFrancisco");
		this.losAngeles = new City("Los Angeles");
		
		this.newYork.addDestination(boston);
		this.newYork.addDestination(providence);
		this.newYork.addDestination(philadelphia);
		this.newYork.addDestination(dallas);
		this.newYork.addDestination(washington);
		this.newYork.addDestination(miami);
		
		this.boston.addDestination(providence);
		
		this.philadelphia.addDestination(newYork);
		this.philadelphia.addDestination(boston);
		
		this.washington.addDestination(miami);
		this.washington.addDestination(chicago);
		
		this.dallas.addDestination(chicago);
		
		this.chicago.addDestination(boston);
		this.chicago.addDestination(sanFrancisco);
		
		this.sanFrancisco.addDestination(losAngeles);
		
		this.losAngeles.addDestination(washington);
	}
	
	
	public static void main(String[] args) {
		TripFinder tripFinder = new TripFinder();
		
		Stack<City> stack = new Stack<City>();
		
		City origin = tripFinder.chicago;
		City destination = tripFinder.newYork;
		
		stack.push(origin);
		origin.setVisited(true);
		System.out.println(stack);
		
		while (!stack.isEmpty() && !stack.peek().equals(destination)) {
			City[] unvisitedDestinations = stack.peek().getUnvisitedDestinations();
			
			if (unvisitedDestinations != null) {
				for ( int i = 0 ; i < unvisitedDestinations.length ; i++ ) {
					stack.push(unvisitedDestinations[i]);
					unvisitedDestinations[i].setVisited(true);
				}
			} else {
				stack.pop();
			}
				
			System.out.println(stack);
		}
		
		if (stack.isEmpty()) {
			System.out.println("Cannot get to " + destination + " from " + origin);
		} else {
			System.out.println("You can travel with us from " + origin + " to " + destination);
		}
	}

}
